/*
 * Created on Oct 12, 2005
 */
package com.simutronics.eclipsefe;

import org.eclipse.swt.graphics.Color;

/**
 * @author Adam Vartanian
 */
public class Highlight {

	private String string;
	private Color background;
	private Color foreground;
	private boolean entireLine;
	private boolean ignoreCase;
	
	public Highlight(String s, Color fg, Color bg, boolean line, boolean ignoreCase) {
		string = s;
		foreground = fg;
		background = bg;
		entireLine = line;
		this.ignoreCase = ignoreCase;
	}

	public Color getBackground() {
		return background;
	}

	public Color getForeground() {
		return foreground;
	}

	public String getString() {
		return string;
	}
	
	public boolean isEntireLine() {
		return entireLine;
	}
	
	public boolean isIgnoreCase() {
		return ignoreCase;
	}
	
	public Color changeForeground(Color newForeground) {
		Color temp = foreground;
		foreground = newForeground;
		return temp;
	}
	
	public Color changeBackground(Color newBackground) {
		Color temp = background;
		background = newBackground;
		return temp;
	}

}
