/*
 * Created on Oct 10, 2005
 */
package com.simutronics.eclipsefe;

import java.util.ArrayList;

import org.eclipse.swt.custom.StyleRange;

public class LineAdder implements Runnable {
	
	private String line;
	private ArrayList<StyleRange> ranges = new ArrayList<StyleRange>();
	private FEView view;
	private String window;
	
	public LineAdder(String targetwindow, String line, ArrayList<StyleRange> ranges, FEView window) {
		this.line = line;
		this.ranges.addAll(ranges);
		this.view = window;
		this.window = targetwindow;
	}
	
	public void run() {
//		System.out.println(window + ":" + line);
		view.appendText(window, line, ranges);
	}
	
	public void add(LineAdder x) {
		if (x != null) {
			int offset = line.length();
			line += x.line;
			for (StyleRange r : x.ranges) {
				r.start += offset;
				ranges.add(r);
			}
		}
	}

	public String getWindow() {
		return window;
	}
}