/*
 * Created on Nov 6, 2005
 */
package com.simutronics.eclipsefe;

import java.util.HashMap;
import java.util.Map;

import com.simutronics.eclipsefe.preferences.VariablesPreferencePage;

/**
 * @author Adam Vartanian
 */
public class VariableService {

	private Map<String, String> vars = new HashMap<String, String>();
	private String charID;
	
	public VariableService(String characterID, Map<String, String> vars) {
		charID = characterID;
		this.vars = vars;
	}
	
	void commit() {
		
	}
	
	public String getVariable(String var) {
		return vars.get(var);
	}
	
	public void setVariable(String var, String value) {
		vars.put(var, value);
		VariablesPreferencePage.setVariable(charID, var, value);
	}
	
	public boolean deleteVariable(String var) {
		vars.remove(var);
		return VariablesPreferencePage.deleteVariable(charID, var);
	}
	
	public int getCounter() {
		if (!vars.containsKey("c")) {
			return 0;
		}
		return Integer.parseInt(vars.get("c"));
	}
	
	public void setCounter(int x) {
		setVariable("c", Integer.toString(x));
	}
	
	public String variableReplacement(String msg) {
		StringBuilder sb = new StringBuilder();
		int i;
		while ((i = msg.indexOf('%')) > -1) {
			sb.append(msg.substring(0, i));
			msg = msg.substring(i);
			if (msg.charAt(1) == '%') {
				sb.append('%');
				msg = msg.substring(2);
			} else {
				int space = msg.indexOf(' ', 1);
				if (space == -1) {
					space = msg.length();
				}
				int per = msg.indexOf('%', 1);
				if (per == -1) {
					per = msg.length();
				}
				int end = Math.min(space, per);
				String var = msg.substring(1, end);
				if (vars.containsKey(var)) {
					if (space == end) {
						msg = vars.get(var) + msg.substring(end);
					} else if (msg.length() == end) {
						msg = vars.get(var);
					} else {
						msg = vars.get(var) + msg.substring(end+1);
					}
				} else {
					sb.append('%');
					msg = msg.substring(1);
				}
			}
		}
		sb.append(msg);
		return sb.toString();
	}
}
